/*
 * hPlayer Extend v 2.1.0 VLC and ACE Plugin  detection and embed
 * More information about the script and how to use - http://hplayer.hmscript.net
 * Event Horizon is used to handle keyboard events.
 *
 * Created ZpVs and JD9496
 * support[at]hmscript.net
 * 3dhotboy[at]gmail.com
 *
 * Copyright (c) 2013 ZpVs and JD9496
 * Released under the License:
 * MIT and GPL licenses.
 */
var hPlayer_Ext = function() {
    var ext_service = {
        __agent:function() {
            var ua = !!top.execScript;
            if(ua){return 'ie';}else {return 'non-ie';}
        },
        __api:function() {
            var doing = {
                status:{
                    0:'',
                    1:'Получение данных видеофайла',
                    2:'Буферизация данных',
                    3:'Воспроизведение',
                    4:'Пауза',
                    5:'Воспроизведение остановленно',
                    6:'Воспроизведение видеофайла законченно',
                    7:'Ошибка воспроизведения'
                },
                pl_list:[],
                KEY:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
                plugin: $('#' + ext_options.init._interface.continer + '-plugin')[0],
                _8 : function (utftext) {
                    var string = "";
                    var i = 0;
                    var c = c1 = c2 = 0;
                    while ( i < utftext.length ) {
                        c = utftext.charCodeAt(i);
                        if (c < 128) {
                            string += String.fromCharCode(c);
                            i++;
                        }
                        else if((c > 191) && (c < 224)) {
                            c2 = utftext.charCodeAt(i+1);
                            string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                            i += 2;
                        }
                        else {
                            c2 = utftext.charCodeAt(i+1);
                            c3 = utftext.charCodeAt(i+2);
                            string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                            i += 3;
                        }
                    }
                    return string;
                },
                _6 : function (input) {
                    var output = "";
                    var chr1, chr2, chr3;
                    var enc1, enc2, enc3, enc4;
                    var i = 0;
                    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
                    while (i < input.length) {
                        enc1 = this.KEY.indexOf(input.charAt(i++));
                        enc2 = this.KEY.indexOf(input.charAt(i++));
                        enc3 = this.KEY.indexOf(input.charAt(i++));
                        enc4 = this.KEY.indexOf(input.charAt(i++));
                        chr1 = (enc1 << 2) | (enc2 >> 4);
                        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                        chr3 = ((enc3 & 3) << 6) | enc4;
                        output = output + String.fromCharCode(chr1);
                        if (enc3 != 64) {
                            output = output + String.fromCharCode(chr2);
                        }
                        if (enc4 != 64) {
                            output = output + String.fromCharCode(chr3);
                        }
                    }
                    output = this._8(output);
                    return output;
                },
                __getPlugin:function() {
                   if(typeof($('#' + ext_options.init._interface.continer + '-plugin')[0]) == "object"){
                       return true;
                   }
                },
                __getPluginState:function() {
                    return (ext_options.init._script.type == 'ace')?this.plugin.version: this.plugin.VersionInfo;
                },
                __getPlaylist:function() {
                    var actual_stream;
                    if(ext_options.init._script.type == 'ace'){
                        actual_stream = ext_options.init._player.stream+'torrent&web';
                    }
                    else {
                        actual_stream = ext_options.init._player.stream+'http&web';
                    }
                        var xmlhttp;
                        try {
                            xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
                        } catch (e) {
                            try {
                                xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
                            } catch (E) {xmlhttp = false;}
                        }
                        if (!xmlhttp && typeof XMLHttpRequest!='undefined') {xmlhttp = new XMLHttpRequest();}
                        xmlhttp.open("GET", actual_stream, false);
                        xmlhttp.send(null);
                       // var playlistItem = this._6(xmlhttp.responseText.replace(xmlhttp.responseText.charAt(0), "")).split('#EXTINF:-1,');
                    var playlistItem = xmlhttp.responseText.split('#EXTINF:-1,');
                        for(var i=1; i<playlistItem.length; i++){
                                if(!ext_options.init._ad.isView){
                                    this.pl_list[0] = [ext_options.init._ad.link,ext_options.init._ad.link];
                                }else {
                                    this.pl_list[0] = [];
                                }
                                var item = playlistItem[i].split('\n');
                                this.pl_list[i] = [item[0],item[1].trim()];
                            }
                    return this.pl_list;
                },
                __controlMethod:function(control, contdata){
                    if (!this.plugin) {
                        setTimeout(this.__controlMethod(control, contdata), 100);
                    }
                    else {
                        switch (control){
                            case 'play':
                                var options = '';
                                var _stream;
                                    _stream = ext_options.init._script.playlist_now;
                                // очищаем плейлист
                                if(ext_options.init._script.type == 'ace'){
                                    this.plugin.playlistClear();
                                }
                                else {
                                    this.plugin.playlist.items.clear();
                                }
                                //добавляем в плейлист урлы.
                                for( var i=0; i<_stream.length; i++){
                                        if(ext_options.init._script.type == 'ace'){
                                           // this.plugin.playlistAdd(_stream[i][1], _stream[i][0]);
                                        }
                                        else {
                                            if(ext_options.init._script.browser == 'ie'){this.plugin.playlist.add(_stream[i][1]);}
                                            else {this.plugin.playlist.add(_stream[i][1], _stream[i][0], options);}
                                        }
                                }
                                //сообщаем количество добавленных файлов.
                                if(ext_options.init._script.type == 'ace'){ext_service.__inf('В плейлист добавлено ('+this.plugin.playlistCount+') ссылки','','i');}
                                else {ext_service.__inf('В плейлист добавлено ('+this.plugin.playlist.items.count+') ссылки','','i');}

                                var itemPlay = Number($('[data-id]').attr('data-id'));

                                if( ext_options.init._script.playlistitemplaing != itemPlay && ext_options.init._script.playlistitemplaing != null){
                                        if(ext_options.init._ad.state && !ext_options.init._ad.isView){
                                            if(ext_options.init._script.type == 'ace'){
                                                this.plugin.playlistLoadPlayer(ext_options.init._script.playlist_now[ext_options.init._script.playlistitemplaing][1]);
                                                this.plugin.playlistPlay();
                                            }
                                            else {this.plugin.playlist.playItem(0);}
                                        }
                                        else {
                                            if(ext_options.init._script.type == 'ace'){
                                                this.plugin.playlistLoadPlayer(ext_options.init._script.playlist_now[ext_options.init._script.playlistitemplaing][1]);
                                                this.plugin.playlistPlay();
                                            }
                                            else {this.plugin.playlist.playItem(Number(ext_options.init._script.playlistitemplaing));}
                                        }
                                    }
                                else {
                                        ext_options.init._script.playlistitemplaing = itemPlay;
                                        if(ext_options.init._ad.state && !ext_options.init._ad.isView){
                                            if(ext_options.init._script.type == 'ace'){
                                                this.plugin.playlistLoadPlayer(ext_options.init._script.playlist_now[ext_options.init._script.playlistitemplaing][1]);
                                                this.plugin.playlistPlay();

                                            }
                                            else {this.plugin.playlist.playItem(0);}
                                        }
                                        else {
                                            if(ext_options.init._script.type == 'ace'){
                                                this.plugin.playlistLoadPlayer(ext_options.init._script.playlist_now[ext_options.init._script.playlistitemplaing][1]);
                                                this.plugin.playlistPlay();
                                            }
                                            else {this.plugin.playlist.playItem(itemPlay);}
                                        }
                                    }
                                // если установленно проигрывание рекламмы то запускаем проверку просмотра.
                                if(!ext_options.init._ad.isView){setTimeout('hPlayer_Ext.api().checkAds()',ext_options.init._ad.time);}
                                break;
                            case 'forward':
                                ext_options.init._script.playlistitemplaing = Number(ext_options.init._script.playlistitemplaing)+1;
                                if(ext_options.init._script.type == 'ace'){
                                    this.__controlMethod('play');
                                }
                                else {this.plugin.playlist.next();}
                                break;
                            case 'backward':
                                ext_options.init._script.playlistitemplaing = Number(ext_options.init._script.playlistitemplaing)-1;
                                if(ext_options.init._script.type == 'ace'){
                                    this.__controlMethod('play');
                                }
                                else {this.plugin.playlist.prev();}
                                break;
                            case 'stop':
                                if(ext_options.init._script.type == 'ace'){
                                    this.plugin.playlistStop(true);
                                }
                                else {
                                    this.plugin.playlist.clear();
                                    this.plugin.playlist.stop();
                                }
                                break;
                            case 'pause':
                                (ext_options.init._script.type == 'ace')? this.plugin.playlistTogglePause(): this.plugin.playlist.togglePause();
                                break;
                            case 'fullscreen':
                                (ext_options.init._script.type == 'ace')?this.plugin.setDisabled(false):'';
                                if(ext_options.init._script.browser == 'ie'){
                                    (ext_options.init._script.type == 'ace')? this.plugin.videoToggleFullscreen(): this.plugin.video.toggleFullscreen();
                                }
                                else {
                                    ext_service.__fullscreen(ext_options.init._interface.continer);
                                    }
                                break;
                            case 'playlist':
                                break;
                            case 'mute':
                                (ext_options.init._script.type == 'ace')? this.plugin.audioToggleMute(): this.plugin.audio.toggleMute();
                                break;
                            case 'ratio':
                                (ext_options.init._script.type == 'ace')? this.plugin.videoAspectRatio = contdata: this.plugin.video.aspectRatio = contdata;
                                break;
                            case 'deinterlace':
                                (ext_options.init._script.type == 'ace')? this.plugin.deinterlaceMode = contdata: this.plugin.video.deinterlace.enable(contdata);
                                break;
                            case 'changevolume':

                                (ext_options.init._script.type == 'ace')? this.plugin.audioVolume = contdata: this.plugin.audio.volume = contdata;
                                break;
                            case 'audioChannel':
                                (ext_options.init._script.type == 'ace')? this.plugin.audioChannel =  parseInt(contdata): this.plugin.audio.channel =  parseInt(contdata);
                                break;
                        }
                    }
                },
                __checker:function(type,data) {
                    if (!ext_service.__api().__getPlugin()) return false;
                    if (!ext_service.__api().__getPluginState()) {
                        this.statusText('<p style="color: red;">PLUGIN NOT FOUND FROM PAGE</p>');
                        return false;
                    }
                        switch (type){
                            case 'start':
                                this.__checker('stop',null);
                                this.statusCheckTimer = setInterval('hPlayer_Ext.api().__checker("checking",null)', 100);
                                break;
                            case 'stop':
                                clearTimeout(this.statusCheckTimer);
                                break;
                            case 'checking':
                                var status;
                                this.mPos();
                                ext_options.init._script.pult = !!__cookie('remote_control');
                                if(ext_options.init._script.pult){ext_service.__pultCommand();}
                                (ext_options.init._script.type == 'ace')? status = this.plugin.state: status = this.plugin.input.state;
                                if(ext_options.init._script.pult_command != ext_options.init._script.work_command && ext_options.init._script.pult_command != ''){
                                    ext_service.__control(ext_options.init._script.pult_command);
                                    ext_options.init._script.work_command = ext_options.init._script.pult_command;
                                }
                                if(ext_options.init._script.pult_command == 'largescreen'){
                                    ext_service.__control(ext_options.init._script.work_command);
                                    ext_options.init._script.pult_command = null;

                                }
                                ext_options.init._script.playError = true;
                                switch (status){
                                    case 2:
                                        if(ext_options.init._script.type == 'ace'){
                                            this.fullscreenWidth();
                                            this.statusText(this.status[status]);
                                            this.plugin.setDisabled(true);
                                            $('.'+ext_options.init._interface.continer+'-playerMediaInfo').html(ext_service.__playTime()+' / '+ext_service.__playTime('end'));
                                        }
                                        else {
                                            this.statusText(this.status[status]);
                                        }
                                        break;
                                    case 3:
                                    case 4:
                                        ext_options.init._script.playError = false;
                                        this.fullscreenWidth();
                                        if(status == 3 && !ext_options.init._ad.isView && ext_options.init._ad.state){
                                            this.statusText('Рекламный ролик');
                                        }else {
                                            this.statusText(this.status[status]+' '+ext_options.init._script.playlist_now[ext_options.init._script.playlistitemplaing][0]);
                                            $('.'+ext_options.init._interface.continer+'-playerMediaInfo').html(ext_service.__playTime()+' / '+ext_service.__playTime('end'));

                                        }
                                        break;
                                    case 6:
                                        ext_options.init._script.playError = true;
                                        $('.ico-pause').addClass('ico-play');
                                        $('.ico-pause').removeClass('ico-pause');
                                        ext_options.init._script.isPause = false;
                                        this.plugin.width =  '1px';
                                        this.plugin.height = '1px';
                                        this.statusText(this.status[status]);
                                        break;
                                    case 7:
                                        if(ext_options.init._script.playError){
                                            this.__controlMethod('play');
                                        }
                                        this.statusText(this.status[status]);
                                        break;
                                    default:
                                        (ext_options.init._script.type == 'ace')?this.plugin.setDisabled(false):'';
                                        this.statusText(this.status[status]);
                                        this.plugin.width =  '1px';
                                        this.plugin.height = '1px';
                                        if(ext_options.init._player.autoplay ){
                                            $('.ico-play').addClass('ico-pause');
                                            $('.ico-play').removeClass('ico-play');
                                            ext_options.init._script.isPause = true;
                                            ext_options.init._player.autoplay = false;
                                            this.__controlMethod('play');
                                        }
                                }
                                var mute;
                                (ext_options.init._script.type == 'ace')? mute = this.plugin.audioMute: mute = this.plugin.audio.mute;
                                if(mute){
                                    $('.ico-volume-up').addClass( 'ico-volume-off' );
                                    $('.ico-volume-up').removeClass('ico-volume-up');
                                }
                                else {
                                    $('.ico-volume-off').addClass( 'ico-volume-up' );
                                    $('.ico-volume-off').removeClass('ico-volume-off');

                                }
                                $('#' + ext_options.init._interface.continer+'-screen').height($('#' + ext_options.init._interface.continer).height()-$('#' + ext_options.init._interface.continer + '-toolbar').height());
                                break;
                        }
                },
                checkAds:function() {
                    var state;
                    (ext_options.init._script.type == 'ace')? state = this.plugin.state: state = this.plugin.input.state;
                    if(ext_options.init._ad.state && !ext_options.init._ad.isView && state != 5){
                        ext_service.__inf('Advertising has been viewed ', !ext_options.init._ad.isView,'i');
                        ext_options.init._ad.isView = true;
                       // (ext_options.init._script.type == 'ace')? this.plugin.playlistRemoveItem(0): this.plugin.playlist.items.remove(0);
                        (ext_options.init._script.type == 'ace')? '':this.__controlMethod('play');

                    }
                },
                hideToolbar:function() {
                    if(!ext_options.init._script.overlayBox){
                        $('#' + ext_options.init._interface.continer+'-toolbar').hide('slide',{ direction: "down" }, 300);
                        $('#' + ext_options.init._interface.continer+'-toolbar').attr("style","height:0px !important;");
                    }
                },
                mPos:function() {
                    if(ext_service.__fullscreenCheck()){
                        document.onmousemove = function (e) {
                            ext_options.init._script.mouseposition =  e.pageX+e.pageY;
                        };
                        if(ext_options.init._script.mousehold != ext_options.init._script.mouseposition){
                            ext_options.init._script.mousehold = ext_options.init._script.mouseposition;
                            $('#' + ext_options.init._interface.continer+'-toolbar').attr("style","height:120px !important;");
                            $('#' + ext_options.init._interface.continer+'-toolbar').show('slide',{ direction: "down" }, 300);
                            ext_options.init._script.toolbarHide = false;
                        }
                        else {
                            if(!ext_options.init._script.toolbarHide){
                                if(!ext_options.init._script.overlayBox){
                                    ext_options.init._script.toolbarHide = true;
                                    setTimeout('hPlayer_Ext.api().hideToolbar()', 5000);
                                }
                            }
                        }
                    }else {
                        $('#' + ext_options.init._interface.continer+'-toolbar').attr("style","height:120px !important;");
                        $('#' + ext_options.init._interface.continer+'-toolbar').show('slide',{ direction: "down" }, 300);
                    }
                },
                fullscreenWidth:function() {
                    this.plugin.width = $('#' + ext_options.init._interface.continer).width();
                    this.plugin.height = $('#' + ext_options.init._interface.continer).height()-$('#' + ext_options.init._interface.continer + '-toolbar').height();

                },
                statusText:function(txt) {
                    $('.'+ext_options.init._interface.continer+'-playerInfo').html('');
                    $('.'+ext_options.init._interface.continer+'-playerInfo').html(txt);
                }
            };
            return doing;
        },
        __inf:function(key,key_info,type_info) {
            switch(type_info){
                case 's':
                    ext_options.init._script.debug ? console.log('Value "'+ key +'" set in ('+ key_info +')'):'';
                    break;
                case 'e':
                    ext_options.init._script.debug ? console.warn('Value '+ key +' ignored as not used'):'';
                    break;
                case 'i':
                    ext_options.init._script.debug ? console.info(key + key_info):'';
                    break;
            }
        },
        __interface:function(wrapper) {
            var interfacePart = {
                'buttons':{
                    largescreen:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerControl',
                        txt:'Широкий экран',
                        icon: 'ico-largescreen',
                        event: function() {ext_service.__control('largescreen');}
                    },
                    changeplayer:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerConfig',
                        txt:'Преключение проигрывателей( Http-Torrent )',
                        icon: 'ico-changeplayer-vlc',
                        event: function() {ext_service.__control('changeplayer');}
                    },
                    backward:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerControlMain',
                        txt:'Предыдущий трек',
                        icon: 'ico-backward',
                        event: function() {ext_service.__control('backward');}
                    },
                    play:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerControlMain',
                        txt:'Play / Pause',
                        icon: 'ico-play',
                        event: function() {ext_service.__control('play');}
                    },
                    forward:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerControlMain',
                        txt:'Forward',
                        icon: 'ico-forward',
                        event: function() {ext_service.__control('forward');}
                    },
                    fullscreen:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerConfig',
                        txt:'Fullscreen',
                        icon: 'ico-fullscreen',
                        event: function() {ext_service.__control('fullscreen');}
                    },
                    stop:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerControl',
                        txt:'Stop',
                        icon: 'ico-stop',
                        event: function() {ext_service.__control('stop');}
                    },
                    mute:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerControl',
                        txt:'Volume',
                        icon: 'ico-volume-up',
                        event: function() {ext_service.__control('mute');}
                    },
                    playlist:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerConfig',
                        txt:'Playlist',
                        icon: 'ico-playlist',
                        event: function() {ext_service.__control('playlist');}
                    },
                    config:{
                        access:false,
                        d_class:ext_options.init._interface.continer+'-playerConfig',
                        txt:'Settings',
                        icon: 'ico-cogs',
                        event: function() {ext_service.__control('config');}
                    }

                },
                'parts':{
                    main:{
                        access:true,
                        box:wrapper,
                        jbox: $('#' + wrapper)
                    },
                    screen:{
                        access:true,
                        box: wrapper + '-screen',
                        jbox: $('#' + wrapper + '-screen')
                    },
                    plugin:{
                        access:true,
                        box:wrapper + '-plugin',
                        jbox: $('#' + wrapper + '-plugin')
                    },
                    toolbar:{
                        access:true,
                        box:wrapper + '-toolbar',
                        jbox: $('#' + wrapper + '-toolbar')
                    }
                }
            };
            $('#' + ext_options.init._interface.continer).addClass(ext_options.init._script.type);
            for (var part in interfacePart.parts){
                switch (part){
                    case 'screen':
                        if(interfacePart.parts[part].access){
                            $('#' + interfacePart.parts['main'].box).append('<div id="' + interfacePart.parts[part].box + '"></div>');
                            if(ext_options.init._player.thumbnail != ''){
                                $('#' + interfacePart.parts[part].box).attr("style", "background: transparent url("+ext_options.init._player.thumbnail+") no-repeat center center");
                            }
                        }
                        break;
                    case 'toolbar':
                        if(ext_options.init._script.type == 'vcam'){
                            interfacePart.parts.toolbar.access = false;
                            ext_options.init._interface.width = '100%';
                            ext_options.init._interface.height = '99%';
                        }
                        if(interfacePart.parts[part].access){
                            $('#' + interfacePart.parts['main'].box).append('<div id="' + interfacePart.parts[part].box + '"></div>');
                            var _controlContiner;
                            switch (ext_options.init._script.type){
                                case 'ace':
                                    _controlContiner = '<div class="'+ext_options.init._interface.continer+'-playerMediaInfo"></div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerControl"></div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerVolume"></div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerControlMain"></div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerConfig"></div>'+
                                        '<div class="'+ext_options.init._interface.continer+'-playerInfo"></div>';
                                    ext_options.init._script.buttons = ext_options.init._script.buttons+':play:stop:config:mute:fullscreen';
                                    break;
                                case 'base':
                                    _controlContiner = '<div class="'+ext_options.init._interface.continer+'-playerMediaInfo">00:00:00 / 00:00:00</div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerControl"></div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerVolume"></div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerControlMain"></div>' +
                                        '<div class="'+ext_options.init._interface.continer+'-playerConfig"></div>'+
                                        '<div class="'+ext_options.init._interface.continer+'-playerInfo"></div>';
                                    ext_options.init._script.buttons = ext_options.init._script.buttons+':largescreen:play:stop:config:mute:fullscreen:forward:backward';
                                    break;
                                case 'vcam':
                                    break;
                                case 'http':
                                    _controlContiner = '<div class="'+ext_options.init._interface.continer+'-playerInfo"></div>';
                                    ext_options.init._script.buttons = '';
                                    break;
                            }
                            var buttons = ext_options.init._script.buttons.split(':');
                            for(var i=0; i<buttons.length; i++){
                                if(buttons[i] != '') interfacePart.buttons[buttons[i]].access = true;
                            }

                        }
                        break;
                    case 'plugin':
                        if(interfacePart.parts[part].access){
                            $('#' + interfacePart.parts['screen'].box).append('<div id="' + interfacePart.parts[part].box + '"></div>');
                        }
                        break;
                    default:
                        interfacePart.parts[part].jbox.html('');
                }
            }
            var _toolbar = $('#' + interfacePart.parts['toolbar'].box);
            _toolbar.append(_controlContiner);
            for (var button in interfacePart.buttons) {
                var newButton = interfacePart.buttons[button];
                if(newButton.access){
                    this.__interfaceButton(newButton.d_class, newButton.txt, newButton.icon,newButton.event);
                }
            }
            $('.'+ext_options.init._interface.continer+'-playerVolume').append('<div id="'+ext_options.init._interface.continer+'-player-volume"></div>');
            ext_service.__volumeSlider();
        },
        __interfaceButton:function(box, title, cls, handler) {
            var inElement = $('.' + box);
            var id = box + '-' + inElement[0].childNodes.length;
            var btn = '<div id="' + id +'" class="btn-player '+cls+'" title="'+ title +'"></div>';
            inElement.append(btn);
            if (handler) {
                $('#' + id).bind('click', {doing: this.__api()}, handler);
            }
        },
        __interfaceButtonSettings:function(box, html, cls, handler) {
            var inElement = $('.' + box);
            var id = box + '-' + inElement[0].childNodes.length;
            var btn = '<div id="' + id +'" class="'+cls+' btn-default" title="'+ html +'">'+ html +'</div>';
            inElement.append(btn);
            if (handler) {
                $('#' + id).bind('click', {doing: this.__api()}, handler);
            }
        },
        __keyboard:function(){
            var E = (function(){
                var register = {};
                var EventHorizonCore = function(parent){
                    this.initedBy = parent || 'EventHorizon Core';
                };
                var eh = EventHorizonCore.prototype;
                eh.add = function(event, callback, phase, stage){
                    var pid = this.genId();
                    register[pid] = {event: event,callback: callback,phase: (phase)? phase :false, stage: stage || 1};
                    document.addEventListener(register[pid]['event'],register[pid]['callback'],register[pid]['phase']);
                    return pid;
                };
                eh.del = function(pid){
                    document.removeEventListener(register[pid]['event'],register[pid]['callback'],register[pid]['phase']);
                    delete register[pid];
                };
                eh.stage = function(pid, stage){
                    out: switch(stage){
                        case(0):
                            if(register[pid]!==0){
                                register[pid].stage=0;
                                document.removeEventListener(register[pid]['event'],register[pid]['callback'],register[pid]['phase']);
                            }
                            break;
                        case(1):
                            if(register[pid]!==1){
                                document.addEventListener(register[pid]['event'],register[pid]['callback'],register[pid]['phase']);
                                register[pid].stage=1;
                            }
                            break;
                        default:
                            if(register[pid].stage){
                                document.addEventListener(register[pid]['event'],register[pid]['callback'],register[pid]['phase']);
                                register[pid].stage=1;
                            }
                            else {
                                document.removeEventListener(register[pid]['event'],register[pid]['callback'],register[pid]['phase']);
                                register[pid].stage=0;
                            }
                            break out;
                    }
                };
                eh.init = function(){
                    var treat = new EventHorizon(this);
                    register.treats = register.treats || {};
                    register.treats[this.genId()] = treat;
                    return treat;
                };
                eh.insert=function(o,mode){
                    for(var i in o){
                        this[i] = (this[i])?((mode)?((o[i].clone)? o[i].clone(): o[i]):this[i]):((o[i].clone)? o[i].clone(): o[i]);
                    }
                };
                eh.genId = function(){
                    var g = "", hash='qwertyuiopasdfghjklzxcvbnm741028963';
                    for (var i = 0; i < 25; i++) g += hash[parseInt(Math.random() * 31)];
                    return g;
                };
                eh.checkMySelf = function(){return (this.checkMySelf)? true:false;};
                return new EventHorizonCore();
            })();
            E.insert({
                keyCallbacks: {
                    17: {
                        recall: '/38/40/',
                        38:function(){
                            var now = (ext_options.init._script.type == 'ace')?ext_service.__api().plugin.audioVolume:ext_service.__api().plugin.audio.volume;
                            if(now !== 200){
                                var stage = (now<195)?now+5:(now+(200-now));
                                ext_service.__control('changevolume', stage);
                                $('#'+ext_options.init._interface.continer+'-player-volume').slider("value", stage);
                            }
                        },
                        40:function(){
                            var now = (ext_options.init._script.type == 'ace')?ext_service.__api().plugin.audioVolume:ext_service.__api().plugin.audio.volume;
                            if(now !== 0){
                                var stage = (now>5)?now-5:now-(5-now);
                                ext_service.__control('changevolume', stage);
                                $('#'+ext_options.init._interface.continer+'-player-volume').slider("value", stage);
                            }
                        },
                        67:function(){ext_service.__control('config')},
                        39:function(){ext_service.__control('forward')},
                        37:function(){ext_service.__control('backward')},
                        192:function(){ext_service.__control('mute')}

                    },
                    18: {
                        recall: '',
                        13:function(){ext_service.__control('fullscreen')},
                        83:function(){ext_service.__control('stop')},
                        80:function(){ext_service.__control('playlist')}
                    },
                    onekey: {
                        recall: '',
                        32: function(){ext_service.__control('play')},
                        27: function(){ext_options.init.isFullscreen=false}
                    }
                }
                ,blockade: '/17/18/13/27/32/38/40/'
                ,startEventsStage: function(e){
                    E.stage(E.ku, 1);
                    E.stage(E.kd, 1);
                    if(E.blockade.indexOf('/' + e.which + '/') >= 0) e.preventDefault();
                    var ec = E.keyCallbacks;
                    if(E.callWay.length > 0){
                        var eci = ec;
                        for(var i = 0; i < E.callWay.length; i++){
                            eci = (e.which === E.callWay[i])?eci:eci[E.callWay[i]];
                        }
                        if(E.callWay[E.callWay.length - 1] !== e.which)E.callWay.push(e.which);
                        if(eci[e.which]){
                            if(eci.recall) if(eci.recall.indexOf('/' + e.which + '/') < 0) E.stage(E.kd, 0);
                            if(eci[e.which] instanceof Function)
                                eci[e.which]();
                        }
                    }else {
                        if(ec[e.which]){
                            E.callWay.push(e.which);
                        }else if(ec.onekey[e.which]){
                            if(ec.onekey.recall.indexOf('/' + e.which + '/') < 0) E.stage(E.kd, 0);
                            if(ec.onekey[e.which] instanceof Function)ec.onekey[e.which]();
                        }
                    }
                }
                ,stopEventsStage: function(e){
                    if(E.callWay.length > 0){
                        while(('/' + E.callWay.join('/') + '/').indexOf(e.which) >= 0){
                            E.callWay.pop();
                        }
                        E.stage(E.ku, 1);
                    }else {
                        E.stage(E.ku, 0);
                    }
                    E.stage(E.kd, 1);
                }
                ,callWay: []
                ,keyboardEventsOn: function(){
                    E.kd = E.add('keydown', E.startEventsStage);
                    E.ku = E.add('keyup', E.stopEventsStage);
                    E.stage(E.ku, 0);
                }
                ,keyboardEventsOff: function(){
                    E.del(E.kd);
                    E.del(E.ku);
                }
            });
            return E;
        },
        __pultCommand:function(){
            var xmlhttp;
            try {
                xmlhttp = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (e) {
                try {
                    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
                } catch (E) {xmlhttp = false;}
            }
            if (!xmlhttp && typeof XMLHttpRequest!='undefined') {xmlhttp = new XMLHttpRequest();}
            xmlhttp.open("GET", "/?pult&control", false);
            xmlhttp.send(null);
                if(xmlhttp.readyState == 4){
                    ext_options.init._script.pult_command = xmlhttp.responseText;
                }
        },
        __control:function(control_type,con_type) {
            if (!ext_service.__api().__getPluginState()) return false;
            this.__inf('For the plugin called event: '+control_type,'','i');
            var config = ext_options.init._script;
            var continer = $('#' + ext_options.init._interface.continer);
            switch (control_type){
                case 'play':
                    if(config.isPause){
                        continer.find('.ico-pause').addClass('ico-play');
                        continer.find('.ico-pause').removeClass('ico-pause');
                        config.isPause = false;
                        this.__api().__controlMethod('pause');
                    }
                    else {
                        config.isPause = true;
                        continer.find('.ico-play').addClass('ico-pause');
                        continer.find('.ico-play').removeClass('ico-play');
                        this.__api().__controlMethod('play');
                    }
                    break;
                case 'stop':
                    if(config.isPause){
                        continer.find('.ico-pause').addClass('ico-play');
                        continer.find('.ico-pause').removeClass('ico-pause');
                        config.isPause = false;
                    }
                    this.__api().__controlMethod('stop');
                    break;
                case 'mute':
                    if(config.mute){
                        continer.find('.ico-volume-off').addClass( 'ico-volume-up' );
                        continer.find('.ico-volume-off').removeClass('ico-volume-off');
                        config.mute = false;
                    }
                    else {
                        config.mute = true;
                        continer.find('.ico-volume-up').addClass( 'ico-volume-off' );
                        continer.find('.ico-volume-up').removeClass('ico-volume-up');
                    }
                    var _volume = $('#'+ext_options.init._interface.continer+'-player-volume');
                        if(_volume.slider("value")== '0'){
                        _volume.slider("value", ext_options.init._script.volume);
                    }
                    else {
                        ext_options.init._script.volume = _volume.slider("value");
                        _volume.slider("value", 0);
                    }
                    this.__api().__controlMethod('mute');
                    break;
                case 'fullscreen':
                    if(config.windowless){}
                    else {
                        this.__api().__controlMethod('fullscreen');
                    }
                    break;
                case 'largescreen':
                    if(ext_options.init._script.ifLarge){
                        $('#' + ext_options.init._interface.continer).removeClass('full');
                        continer.find('.ico-normalscreen').addClass('ico-largescreen');
                        continer.find('.ico-normalscreen').removeClass('ico-normalscreen');
                        ext_options.init._script.ifLarge = false;
                    }
                    else {
                        ext_options.init._script.ifLarge = true;
                        $('#' + ext_options.init._interface.continer).addClass('full');
                        continer.find('.ico-largescreen').addClass('ico-normalscreen');
                        continer.find('.ico-largescreen').removeClass('ico-largescreen');
                    }
                    break;
                case 'changeplayer':
                    if(ext_options.init._script.type != 'ace'){
                        ext_options.init._script.type = 'ace';
                        continer.find('.ico-changeplayer-vlc').addClass('ico-changeplayer-ace');
                        continer.find('.ico-changeplayer-vlc').removeClass('ico-changeplayer-vlc');
                    }
                    else {
                        ext_options.init._script.type = 'base';
                        continer.find('.ico-changeplayer-ace').addClass('ico-changeplayer-vlc');
                        continer.find('.ico-changeplayer-ace').removeClass('ico-changeplayer-ace');
                    }
                    this.__control('stop');
                    this.__player();
                    ext_options.init._script.playlist_now = ext_service.__api().__getPlaylist();
                    break;
                case 'config':
                    if(config.configBox){
                        config.overlayBox = false;
                        config.configBox = false;
                        $('#' +  ext_options.init._interface.continer+'-infoBox').remove();
                        $('#' +  ext_options.init._interface.continer+'-plugin').removeClass('infoBox-overlay');
                    }
                    else {
                        config.overlayBox = true;
                        if(config.playlistBox){
                            config.playlistBox = false;
                            $('#' +  ext_options.init._interface.continer+'-infoBox').remove();
                            $('#' +  ext_options.init._interface.continer+'-plugin').removeClass('infoBox-overlay');
                        }
                        config.configBox = true;
                        $('#' + ext_options.init._interface.continer+'-plugin').addClass('infoBox-overlay');
                        $('#' + ext_options.init._interface.continer+'-screen').append('<div id="' + ext_options.init._interface.continer+'-infoBox' + '"></div>');
                        $('#' + ext_options.init._interface.continer+'-infoBox').append('<div class="infoBox-inner">' +
                            '<p>Aspect ratio for video screen</p><span class ="SettingsRatio"></span>' +
                            '<p>Deinterlacing modes</p><span class ="SettingsDeint"></span>' +
                            '<p>Audio channels</p><span class ="SettingsAudio"></span>' +
                            '</div>');
                        var videoRatio = 'SettingsRatio';
                        this.__interfaceButtonSettings(videoRatio, '1:1', 'btn', function(event) {ext_service.__control('ratio','1:1');});
                        this.__interfaceButtonSettings(videoRatio, '4:3', 'btn', function(event) {ext_service.__control('ratio','4:3');});
                        this.__interfaceButtonSettings(videoRatio, '16:9', 'btn', function(event) {ext_service.__control('ratio','16:9');});
                        this.__interfaceButtonSettings(videoRatio, '16:10', 'btn', function(event) {ext_service.__control('ratio','16:10');});
                        this.__interfaceButtonSettings(videoRatio, '221:100', 'btn', function(event) {ext_service.__control('ratio','221:100');});
                        this.__interfaceButtonSettings(videoRatio, '5:4', 'btn', function(event) {ext_service.__control('ratio','5:4');});
                        var videoDeinter = 'SettingsDeint';
                        this.__interfaceButtonSettings(videoDeinter, 'blend', 'btn', function(event) {ext_service.__control('deinterlace','blend');});
                        this.__interfaceButtonSettings(videoDeinter, 'bob', 'btn', function(event) {ext_service.__control('deinterlace','bob');});
                        this.__interfaceButtonSettings(videoDeinter, 'linear', 'btn', function(event) {ext_service.__control('deinterlace','linear');});
                        this.__interfaceButtonSettings(videoDeinter, 'mean', 'btn', function(event) {ext_service.__control('deinterlace','mean');});
                        this.__interfaceButtonSettings(videoDeinter, 'yadif', 'btn', function(event) {ext_service.__control('deinterlace','yadif');});
                        this.__interfaceButtonSettings(videoDeinter, 'yadif2x', 'btn', function(event) {ext_service.__control('deinterlace','yadif2x');});
                        this.__interfaceButtonSettings(videoDeinter, 'discard', 'btn', function(event) {ext_service.__control('deinterlace','discard');});
                        var audioChannel = 'SettingsAudio';
                        this.__interfaceButtonSettings(audioChannel, 'stereo', 'btn', function(event) {ext_service.__control('audioChannel','1');});
                        this.__interfaceButtonSettings(audioChannel, 'r :stereo', 'btn', function(event) {ext_service.__control('audioChannel','2');});
                        this.__interfaceButtonSettings(audioChannel, 'left', 'btn', function(event) {ext_service.__control('audioChannel','3');});
                        this.__interfaceButtonSettings(audioChannel, 'right', 'btn', function(event) {ext_service.__control('audioChannel','4');});
                        this.__interfaceButtonSettings(audioChannel, 'dolby', 'btn', function(event) {ext_service.__control('audioChannel','5');});
                    }
                    break;
                case 'playlist':
                    if(config.playlistBox){
                        config.overlayBox = false;
                        config.playlistBox = false;
                        $('#' +  ext_options.init._interface.continer+'-infoBox').remove();
                        $('#' +  ext_options.init._interface.continer+'-plugin').removeClass('infoBox-overlay');
                    }
                    else {
                        config.overlayBox = true;
                        if(config.configBox){
                            config.configBox = false;
                            $('#' +  ext_options.init._interface.continer+'-infoBox').remove();
                            $('#' +  ext_options.init._interface.continer+'-plugin').removeClass('infoBox-overlay');
                        }
                        config.playlistBox = true;
                        $('#' + ext_options.init._interface.continer+'-plugin').addClass('infoBox-overlay');
                        $('#' + ext_options.init._interface.continer+'-screen').append('<div id="' + ext_options.init._interface.continer+'-infoBox' + '"></div>');
                        $('#' + ext_options.init._interface.continer+'-infoBox').append('<ul class="infoBox-inner"></ul>');
                         var i = 0;
                        var playlist_load = ext_options.init._script.playlist_now;
                        for(i; i<playlist_load.length; i++){
                            if(i==0){}else {
                                if(ext_options.init._player.stream != ''){
                                    $('.infoBox-inner').append('<li data-id="'+i+'" data-play="'+playlist_load[i][1]+'">'+ playlist_load[i][0]+'</li>');
                                }

                            }
                        }
                        $('.infoBox-inner li').bind("click", function(){
                            ext_options.init._script.playlistitemplaing = this.getAttribute('data-id');

                            ext_service.__api().__controlMethod('play');});
                    }
                    this.__api().__controlMethod('playlist');
                    break;
                case 'backward':
                    this.__api().__controlMethod('backward');
                    break;
                case 'forward':
                    this.__api().__controlMethod('forward');
                    break;
                case 'ratio':
                    this.__api().__controlMethod('ratio',con_type);
                    break;
                case 'deinterlace':
                    this.__api().__controlMethod('deinterlace',con_type);
                    break;
                case 'changevolume':
                    this.__api().__controlMethod('changevolume',con_type);
                    break;
                case 'audioChannel':
                    this.__api().__controlMethod('audioChannel',con_type);
                    break;
            }
        },
        __player:function() {
            var hScreen = ext_options.init;
            var element, el = document.getElementById(hScreen._interface.continer + '-plugin');
            if (el) {
                if (ext_options.init._script.browser == 'ie') {
                    var att = '';
                    var par = '';
                    att += 'id="' + ext_options.init._interface.continer + '-plugin"';
                    att += 'bgcolor="' + ext_options.init._interface.background + '"';
                    par += '<param name="ShowDisplay" value="true" />';
                    par += '<param name="id" value="' + ext_options.init._interface.continer + '-plugin" />';
                    par += '<param name="bgcolor" value="' + ext_options.init._interface.background + '" />';
                    par += '<param name="width" value="' + ext_options.init._interface.width + '" />';
                    par += '<param name="height" value="' + ext_options.init._interface.height + '" />';
                    if(ext_options.init._script.type == 'ace'){
                        par += '<embed type="'+ ext_options.init._player.ace.MimeType +'"   width="' + ext_options.init._interface.width + '" height="' + ext_options.init._interface.height + '"></embed>';
                        el.outerHTML = '<object classid="'+ ext_options.init._player.ace.classid +'"' + att + par + '</object>';
                    }
                    else {
                        att += 'toolbar="false"';
                        par += '<param name="toolbar" value="false" />';
                        if(ext_options.init._player.windowless){
                            att += 'windowless="' + ext_options.init._interface.windowless + '"';
                            par += '<param name="windowless" value="' + ext_options.init._interface.windowless + '" />';
                        }
                        if(ext_options.init._player.autoloop){
                            att += 'loop="' + ext_options.init._interface.autoloop + '"';
                            par += '<param name="loop" value="' + ext_options.init._interface.autoloop + '" />';
                        }
                        par += '<embed type="'+ ext_options.init._player.vlc.MimeType +'"   width="' + ext_options.init._interface.width + '" height="' + ext_options.init._interface.height + '"></embed>';
                        el.outerHTML = '<object classid="'+ ext_options.init._player.vlc.classid +'"' + att + par + '</object>';
                    }
                    element = document.getElementById(hScreen._interface.continer + '-plugin');
                }
                else {
                    var AXO = document.createElement('object');
                    if(ext_options.init._script.type == 'ace'){
                        AXO.setAttribute("type", ext_options.init._player.ace.MimeType);
                        AXO.setAttribute("force", 'true');
                        AXO.setAttribute("fscontrolsenable", '0');
                        AXO.setAttribute("defaultcontrolsforstream", "0");
                        if(ext_options.init._player.autoplay){
                            AXO.setAttribute("defaultcontrolsforstream", "0");
                        }
                    }
                    else {
                        AXO.setAttribute("type", ext_options.init._player.vlc.MimeType);
                        AXO.setAttribute("toolbar", "false");
                        AXO.setAttribute("allowfullscreen", "false");

                        if(ext_options.init._player.windowless){
                            AXO.setAttribute("windowless", ext_options.init._player.windowless);
                        }
                        if(ext_options.init._player.autoloop){
                            AXO.setAttribute("autoloop", ext_options.init._player.autoloop);
                        }
                    }
                    AXO.setAttribute("id", ext_options.init._interface.continer + '-plugin');
                    AXO.setAttribute("bgcolor", ext_options.init._interface.background);
                    AXO.setAttribute("width", ext_options.init._interface.width);
                    AXO.setAttribute("height", ext_options.init._interface.height);
                    el.parentNode.replaceChild(AXO, el);

                    element = AXO;
                }
            }
            if (!ext_service.__api().__getPluginState()) return false;
            ext_service.__inf('Mounted plugin - ', ext_service.__version(),'i');
            return element;
        },
        __playTime:function(type){
            var __str ={
                video_time:function(type_time) {
                    if(type_time == 'end'){
                        if(ext_options.init._script.type == 'ace'){
                            return $('#' + ext_options.init._interface.continer + '-plugin')[0].inputLength/1000;
                        }
                        else {
                            return $('#' + ext_options.init._interface.continer + '-plugin')[0].input.length/1000;
                        }
                    }
                    else {
                        if(ext_options.init._script.type == 'ace'){
                            return $('#' + ext_options.init._interface.continer + '-plugin')[0].inputTime/1000+1;
                        }
                        else {
                            return $('#' + ext_options.init._interface.continer + '-plugin')[0].input.time/1000+1;
                        }
                    }

                },
                time:function(timepart, length) {
                    var str = '' + timepart;
                    while (str.length < length) {
                        str = '0' + str;
                    }
                    return str;
                }
            };
            var video_time = parseInt( __str.video_time(type));
            var seconds = video_time;
            var minutes = 0;
            var hour = 0;

            if(seconds == 0){}
            if(seconds > 60){
                minutes = Math.floor(seconds/60);
                seconds = parseInt((seconds -(minutes*60)));
            }
            if(seconds > 3600){
                hour = Math.floor(minutes/60);
                minutes = Math.floor(seconds/60);
                seconds = parseInt((seconds -(minutes*60)));
            }
            return __str.time(hour,2) + ':' + __str.time(minutes,2) + ':' + __str.time(seconds,2);
        },
        __volumeSlider:function() {
            var _volume = $('#'+ext_options.init._interface.continer+'-player-volume');
            _volume.slider({
                range: "min",
                min: 0,
                max: 150,
                value: 50,
                animate: true,
                start: function(event,ui) {
                },
                slide: function(event, ui) {
                    var value = _volume.slider('value');
                },
                stop: function(event,ui) {
                     ext_service.__control('changevolume',ui.value);
                }

            });
        },
        __fullscreen:function(dom) {
            var element = document.getElementById(dom);
            if(this.__fullscreenCheck()){
                if (document.cancelFullScreen) {document.cancelFullScreen();}
                else if (document.mozCancelFullScreen) {document.mozCancelFullScreen();}
                else if (document.webkitCancelFullScreen) {document.webkitCancelFullScreen();}
            }
            else {
                if (element.requestFullscreen) {element.requestFullscreen();}
                else if (element.webkitRequestFullscreen) {element.webkitRequestFullscreen();}
                else if (element.mozRequestFullScreen) { element.mozRequestFullScreen();}
            }
        },
        __fullscreenCheck:function () {
           var fs_state = false;
            if (document.FullscreenElement != null || document.webkitFullscreenElement != null || document.mozFullscreenElement != null){
                fs_state = true;
            }
            return fs_state;
        },
        __version:function(){
            var pl_version;
            if(ext_options.init._script.type == 'ace'){
                pl_version = 'ACE Stream plugin ' +$('#' + ext_options.init._interface.continer + '-plugin')[0].version;
            }
            else {
                pl_version = 'VLC plugin ' +$('#' + ext_options.init._interface.continer + '-plugin')[0].VersionInfo;
            }
            return pl_version;
        }
    };
    var ext_options = {
        defaults:{
            _script:{
                debug: false,
                browser: 'non-ie',
                type: 'base',
                buttons:'',
                api_url:'http://hplayer.hmscript.net/api.php?pl=',
                mute:false,
                toolbarHide:true,
                overlayBox:false
            },
            _player:{
                vlc: {
                    Name: 'VideoLAN VLC ActiveX Plugin',
                    ActiveX: 'VideoLAN.VLCPlugin.2',
                    MimeType: 'application/x-vlc-plugin',
                    classid: 'clsid:9BE31822-FDAD-461B-AD51-BE1D1C159921'
                },
                ace: {
                    Name: 'VLC Multimedia Plug-in',
                    ActiveX: 'VideoLAN.VLCPlugin.2',
                    MimeType: 'application/x-acestream-plugin',
                    classid: 'clsid:79690976-ED6E-403c-BBBA-F8928B5EDE17'
                },
                autoplay: false,
                autoloop: false,
                windowless: false,
                thumbnail:'',
                stream: ''
            },
            _interface:{
                continer: 'hPlayer',
                width: '936px',
                height: '464px',
                background: '#000000'
            },
            _ad:{
                state: false,
                link: '',
                time: 10000,
                isView: false
            }
        }
    };
    return{
        init:function(bConfig,eConfig){

            var config;
            ext_options.init = ext_options.defaults;
            ext_service.__inf('Check the current settings','','i');
            var settings = ext_options.init;
            settings._script.browser = ext_service.__agent();
            settings._script.work_command = null;
            ext_service.__inf('Check the browser','','i');
            if(bConfig != null){
            ext_service.__inf('Checking for key changes to load and initialize the plugin','','i');
                for (config in bConfig) {
                    switch (config) {
                        case  'debug':settings._script.debug = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'type':settings._script.type = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'wrapper':settings._interface.continer = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'width':settings._interface.width = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'height':settings._interface.height = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'background':settings._interface.background = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'windowless':settings._player.windowless = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'autoplay':settings._player.autoplay = bConfig[config]; ext_service.__inf(config,bConfig[config],'s');break;
                        case  'autoloop':settings._player.autoloop = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'stream':settings._player.stream = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'thumbnail':settings._player.thumbnail = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'ads_link':settings._ad.link = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'ads_time':settings._ad.time = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'ads':settings._ad.state = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'buttons':settings._script.buttons = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        case  'api_url':settings._script.buttons = bConfig[config];ext_service.__inf(config,bConfig[config],'s');break;
                        default:ext_service.__inf(config,bConfig[config],'e');
                    }
                }
            }
            else {
            ext_service.__inf('Check for key extension to load and initialize the plugin','','i');
                for (config in eConfig) {
                    switch (config) {
                        case  'debug':settings._script.debug = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'type':settings._script.type = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'wrapper':settings._interface.continer = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'width':settings._interface.width = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'height':settings._interface.height = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'background':settings._interface.background = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'windowless':settings._player.windowless = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'autoplay':settings._player.autoplay = eConfig[config]; ext_service.__inf(config,eConfig[config],'s');break;
                        case  'autoloop':settings._player.autoloop = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'stream':settings._player.stream = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'thumbnail':settings._player.thumbnail = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'ads_link':settings._ad.link = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'ads_time':settings._ad.time = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'ads':settings._ad.state = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'buttons':settings._script.buttons = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        case  'api_url':settings._script.buttons = eConfig[config];ext_service.__inf(config,eConfig[config],'s');break;
                        default:
                            ext_service.__inf(config,eConfig[config],'e');
                    }
                }
            }
            ext_service.__interface(settings._interface.continer);
            ext_service.__player();
            ext_service.__api().__checker('start',null);
            settings._script.playlist_now = ext_service.__api().__getPlaylist();
            ext_service.__keyboard().keyboardEventsOn();
            (!!__cookie('large_screen'))? ext_service.__control('largescreen',null):'';
        },
        api:function(){
            return ext_service.__api();
        },
        control:function(type,config){
            ext_service.__control(type);
        }
    }
}();