/* Created: HM:Script
 *  Website: http://hmscript.net
 *     User: ZpVs
 *     Date: 23.04.13
 *     Time: 16:05
 *  Version: 1.0.0
 * HM:SCRIPT Interface
 */
var slider_position=1;
var popup_type = ['error','success'];
var slider_total;
function __query(url, param, success_function) {
    var http;
    try {
        http = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
        try {
            http = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (E) {
            http = false;
        }
    }
    if (!http && typeof XMLHttpRequest!='undefined') {
        http = new XMLHttpRequest();
    }
    xmlHttp = http;
    xmlHttp.open("POST", url, true);
    xmlHttp.onreadystatechange = success_function;
    xmlHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xmlHttp.send(param);
}
function __cookie(param,command){
    switch (command){
        case 'view':
            var strEnd = document.cookie.indexOf (";", param);
            if (strEnd == -1)
                strEnd = document.cookie.length;
            return unescape(document.cookie.substring(param, strEnd));
            break;
        case 'delete':
            var cookie_date = new Date ( );  // Текущая дата и время
            cookie_date.setTime ( cookie_date.getMonth()-1);
            document.cookie = param +'=; expires='+cookie_date.toGMTString()+';';
            break;
        default:
            var key = param + "=";
            var i = 0;
            while (i < document.cookie.length) {
                var j = i + key.length;
                if (document.cookie.substring(i, j) == key)
                    return __cookie(j,'view');
                i = document.cookie.indexOf(" ", i) + 1;
                if (i == 0)
                    break;
            }
            return null;
    }
}
function __popup(str,type){
    $('.popup').remove();
    switch (type){
        case'error':
            $('[data-html]').prepend('<div class="box_red popup"><strong>Error!</strong> '+str+'</div>');
            break;
        case'success':
            $('[data-html]').prepend('<div class="box_green popup"><strong>OK!</strong> '+str+'</div>');
            break;
    }
    $('.popup').fadeOut(4000);
}
function __slide(){
    var slider_width = $('.featured').width();
    setTimeout(function() {
        slider_position++;
        if (slider_position>slider_total) slider_position=1;
        $('.featured-inner').animate({left: -((slider_position-1)*slider_width)+'px'},1000);
        __slide();
    }, 8000);
}
function EnableCommentButton() {
    $('[data-addcomment]').prop("disabled", false);
}
var _Url = window.location;
$(document).ready(function(){
    switch (__cookie('errors')) {
        case 'register':
            __popup('Такой e-mail уже зарегистрирован.',popup_type[0]);
            break;
        case 'register_email':
            __popup('Не верный  e-mail.',popup_type[0]);
            break;
        case 'forgot_email':
            __popup('Такой e-mail не зарегистрирован.',popup_type[0]);
            break;
    }
    $('[data-number]').bind("change keyup input click", function() {
        if (this.value.match(/[^0-9]/g)) {
            this.value = this.value.replace(/[^0-9]/g, '');
        }
    });
    $('[data-checkbox]').bind("change keyup input click", function() {
        ($(this).prop('checked'))? $('#submitAction').prop("disabled", false):$('#submitAction').prop("disabled", true);
    });
    $('[data-pay-submit]').bind("change keyup input click", function() {
        if($("#payAmount").val() > 0){
            __query( "/?user&finance&deposit", "pamount="+ $("#payAmount").val() +"&pid="+ $("#payID").val() ,function(){
                if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete") {
                    if(xmlHttp.responseText == 'success'){
                         $("#depositForm").submit();
                    }
                }
            });
        }
    });
    $('[data-bonus]').bind("change keyup input click", function() {
        __query( "/?user&finance&bonus", "voucher="+ $(".bonus").val() ,function(){
            if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete") {
                if(xmlHttp.responseText == 'bonus'){
                    document.location.href= '?user&finance';
                }
                else {
                    $('.bonus').attr("value", '');
                }
            }
        });
      });
    $('[data-addcomment]').bind("change keyup input click", function() {
         var comment = $('[name="comment"]');
        if (comment[0].value != '') {
            var container = document.getElementById('data-commentlist');
            __query( "/?comment", "add="+comment[0].value+'&id='+container.getAttribute('data-id'),function(){
                if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete") {
                    var new_element = document.createElement('li');
                    new_element.setAttribute('class','comment');
                    new_element.innerHTML = xmlHttp.responseText;
                    container.insertBefore(new_element, container.firstChild);
                    comment[0].value = '';
                }
            });
            $('[data-addcomment]').prop("disabled", true);
            setTimeout("EnableCommentButton()",30000);
        }
        else{
            __popup('Empty comment data','error');
        }
    });


    $('#paysystemlist').find('span').click(function(){
        $('#paysystemlist span').removeClass('paysysselect');
        $('#payAmount').attr("value", '');
        $(this).addClass('paysysselect');
        $('#paySystem').prop("disabled", false);
        $('[name="ik_pw_via"]').prop("disabled", false);
        $('[name="ik_act"]').prop("disabled", false);
        $('#paySystem').attr('value',$(this).attr('data-system'));
    });
    $('.langlist li').click(function(){
        var channelsBox = $('.content').find('.channelGridItem');
        for(var i=0; i<channelsBox.length; i++){
            if($(this).attr('data-linc') == null){
                channelsBox[i].setAttribute("style", "display: inline-block;");
                $('[data-btnlng]').html('Язык вещания <span class="caret"></span>');
            }
            else {
                if($(this).attr('data-linc') == channelsBox[i].getAttribute('data-language')){
                    channelsBox[i].setAttribute("style", "display: inline-block;");
                    $('[data-btnlng]').html($(this).find('a').html()+' <span class="caret"></span>');
                }
                else {
                    channelsBox[i].setAttribute("style", "display: none;");
                }

            }
        }
    });
    $('.viewlist li').click(function(){
        var channels = document.getElementsByClassName('channelGridItem');
        var chBox = [];
        var inBox = $('.content');
        for (var i = 0; i < channels.length; ++i) {
            chBox.push(channels[i]);
        }
        switch (this.getAttribute("data-sort")){
            case 'fh':
                chBox.sort(function(a, b) {
                    return +a.getAttribute("data-view") - +b.getAttribute("data-view");
                });
                $('[data-btnviews]').html($(this).find('a').html()+' <span class="caret"></span>');
                break;
            case 'fl':
                chBox.sort(function(a, b) {
                    return +b.getAttribute("data-view") - +a.getAttribute("data-view");
                });
                $('[data-btnviews]').html($(this).find('a').html()+' <span class="caret"></span>');
                break;
        }
        chBox.forEach(function(el) {
            inBox.append(el);
        });
    });
    $('.accesslist li').click(function(){
        var channelsBox = $('.content').find('.channelGridItem');
        var i=0;
        switch (this.getAttribute("data-access")){
            case 'free':
                for(i; i<channelsBox.length; i++){
                    channelsBox[i].setAttribute("style", "display: none;");
                    if(!channelsBox[i].getAttribute('data-access') == 1){
                        channelsBox[i].setAttribute("style", "display: inline-block;");
                    }
                    $('[data-btnaccess]').html($(this).find('a').html()+' <span class="caret"></span>');
                }
                break;
            case 'pay':
                for(i; i<channelsBox.length; i++){
                    channelsBox[i].setAttribute("style", "display: none;");
                    if(!channelsBox[i].getAttribute('data-access') == 0){
                        channelsBox[i].setAttribute("style", "display: inline-block;");
                    }
                    $('[data-btnaccess]').html($(this).find('a').html()+' <span class="caret"></span>');
                }
                break;
            default :
                for(i; i<channelsBox.length; i++){
                    channelsBox[i].setAttribute("style", "display: inline-block;");
                }
                break;
        }
    });
    $('.ord-sub').click(function(){
        __query( "/?user&subs", "coast="+ $('.tarif.selected').attr('data-coast') +"&confirm=",function(){
            if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete") {
                if(xmlHttp.responseText == 'success'){
                    document.location.href= '?user&subs';
                }
                else {

                }
            }
        });

    });
    $('.tarif').click(function(){
        var tarifs = $(this).parent().find('.tarif');
        for(var i=0; i<tarifs.length; i++){
            $(tarifs[i]).removeClass('selected');
        }
        $(this).addClass('selected');
        var coast = $(this).attr('data-coast');
        $('.subsBox label').html('');
        __query( "/?user&subs", "u_balance=",function(){
            if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete") {

                if((parseInt(xmlHttp.responseText) - parseInt(coast))>=0){
                    $('.ord-sub').prop("disabled", false);
                }
                else {
                    $('.ord-sub').prop("disabled", true);
                    $('.subsBox label').append('<div class="alert alert-danger">Суммы на вашем счету не достаточно для подключения услуги</div>');
                }

            }
        });

    });
    $('.pultControl button').bind("click touchend", function(){
        switch ($(this).attr('data-action')){
            case 'play':
                if($(this).hasClass('play')){
                    $(this).removeClass('play');
                    $(this).addClass('pause');
                }
                else {
                    $(this).removeClass('pause');
                    $(this).addClass('play');
                }
                break;
            case 'mute':
                if($(this).hasClass('volume-up')){
                    $(this).removeClass('volume-up');
                    $(this).addClass('volume-off');
                }
                else {
                    $(this).removeClass('volume-off');
                    $(this).addClass('volume-up');
                }
                break;
        }
        __query( "/?pult", "action="+$(this).attr('data-action'),function(){
        });

    });
    $('.tv-settings').find('input[type="checkbox"]').click(function(){
        if(this.checked){
            __query( "/?user&tv", "user="+this.getAttribute('name'),function(){});
        }
        else {
            __query( "/?user&tv", "clear="+this.getAttribute('name'),function(){});
        }
    });
    $('.plus-button').click(function(){
        __query( "/?user&tv", "channel="+this.getAttribute('data-id'),function(){});
    });
    slider_total = $('#featured-inner').children().length;
    __slide();

});