<?php
/* Created: HM:Script
*  Website: http://hmscript.net
*     User: zpVs
*     Date: 22.03.13
*     Time: 10:10
*  Version: 1.5.0
*   Script: hStation CMS
*/
global $core;
if (!empty($core::$engine->a_get_index[1])) {
    switch ($core::$engine->a_get_index[1]) {
        case 'login':
            if ($core::$session->getState()) {
                __redirect('user&profile');
            } else {
                $oauth = new Core\Kernel\HmsOauth;
                switch ($core::$engine->a_get_index[2]) {
                    case 'gl_auth':
                        $oauth->provider = 'google';
                        break;
                    case 'vk_auth':
                        $oauth->provider = 'vkontakte';
                        break;
                    case 'fb_auth':
                        $oauth->provider = 'facebook';
                        break;
                    default:
                        $oauth->provider = '';
                }
                $oauth->initAuth();
                if (!isset($_GET['code'])) {
                    $oauth->getAuthCode();
                } else {
                    $oauth->getAuthData($_GET['code']);
                }

                if (!empty($oauth->authdata['email'])) {
                    if ($core::$session->authSocial($oauth->authdata['email'])) {
                    } else {
                        $core::$dbs->addFirst($oauth->authdata['email'], __uniPass());
                        $core::$session->authSocial($oauth->authdata['email'], $oauth->authdata['name']);
                    }
                    $default = $oauth->authdata["avatar"];
                    $new_avatar = $core::CONTPATH.'uploads/images/'.md5($oauth->authdata['email']).'.png';
                    copy($default, $new_avatar);
                    header("Location:".$core::$dbs->d_cfg['site_url'].'/?user&profile');
                }
            }
            break;
        case 'logout':
            if ($core::$session->getState()) {
                $core::$session->destroyAuth();
                __redirect();
                exit();
            }
            break;
        case 'register':
            if ($core::$session->getState()) {
                __redirect('user&profile');
            } else {
                if ($core::$engine->query_post) {
                    $user= $_POST['user'];
                    if (!empty($user["email"]) && $user["agree"] == '1') {
                        $newUserMail = $user['email'];
                        $checkMailType = explode('@', $newUserMail);
                        if (count($checkMailType) == 2) {
                            $newPassword = __uniPass();
                            if (!$core::$dbs->checkMail($newUserMail)) {
                                if ($core::$dbs->addFirst($newUserMail, $newPassword)) {
                                    $url = $core::$dbs->d_cfg['site_url'];
                                    $name = $core::$dbs->d_cfg['site_name'];
                                    $m_tpl = file_get_contents($core::ENGPATH.'service/mailerTemplate/register.html');
                                    $m_tpl = $core::$template->__rT('url', $url, $m_tpl);
                                    $m_tpl = $core::$template->__rT('sitename', $name, $m_tpl);
                                    $m_tpl = $core::$template->__rT('register_user', $newUserMail, $m_tpl);
                                    $m_tpl = $core::$template->__rT('register_pass', $newPassword, $m_tpl);
                                    $core::$mailer->_postWhere = $newUserMail;
                                    $core::$mailer->_postSubject = _T_MAIL_SEND." ".$name;
                                    $core::$mailer->_postTemplate = $m_tpl;
                                    $core::$mailer->SendMail();
                                     __redirect('auth&login');
                                }
                            } else {
                                $core::$session->addSessionValue('errors', 'register');
                                __redirect('auth&register');
                            }
                        } else {
                            $core::$session->addSessionValue('errors', 'register_email');
                            __redirect('auth&register');
                        }
                    }
                } else {
                    $core::$template->parts['body']['file'] = 'inc/register.form.html';
                    $core::$template->tags['title'] = $core::$template->tags['title'].': '._T_REGISTER;
                }
            }
            break;
        case 'forgot':
            if ($core::$session->getState()) {
                __redirect('user&profile');
            } else {
                if ($core::$engine->query_post) {
                    $user= $_POST['user'];
                    $newUserMail = $user['email'];
                    $checkMailType = explode('@', $newUserMail);
                    if (count($checkMailType) == 2) {
                        $recoverUserMail = mf_guard($user['email']);
                        $newPassword = __uniPass();
                        if ($core::$dbs->checkMail($recoverUserMail)) {
                            if ($core::$dbs->editPass($core::$dbs->getUserKey($recoverUserMail), $newPassword)) {
                                $url = $core::$dbs->d_cfg['site_url'];
                                $name = $core::$dbs->d_cfg['site_name'];
                                $m_tpl = file_get_contents($core::ENGPATH.'service/mailerTemplate/recover.html');
                                $m_tpl = $core::$template->__rT('url', $url, $m_tpl);
                                $m_tpl = $core::$template->__rT('sitename', $name, $m_tpl);
                                $m_tpl = $core::$template->__rT('user', $recoverUserMail, $m_tpl);
                                $m_tpl = $core::$template->__rT('password', $newPassword, $m_tpl);
                                $m_tpl = $core::$template->__rT('now', date('j-m-Y в H:i:s'), $m_tpl);
                                $core::$mailer->_postWhere = $recoverUserMail;
                                $core::$mailer->_postSubject = _T_MAIL_FORGOT." ".$name;
                                $core::$mailer->_postTemplate = $m_tpl;
                                $core::$mailer->SendMail();
                                __redirect('auth&login');
                            }
                        } else {
                            $core::$session->addSessionValue('errors', 'forgot_email');
                            __redirect('auth&forgot');
                        }
                    } else {
                        $core::$session->addSessionValue('errors', 'register_email');
                        __redirect('auth&forgot');
                    }
                } else {
                    $core::$template->parts['body']['file'] = 'inc/forgot.form.html';
                    $core::$template->tags['title'] = $core::$template->tags['title'].': '._T_FORGOT;
                }
            }
            break;
    }
}
