<?php namespace Core\Kernel;

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: JD9496
*     Date: 23.04.13
*     Time: 20:18
*  Version: 1.0.0
*   Script: hStation CMS
*/
class HmsAccess
{
    private $default_access;
    private $role_access;
    public function __construct()
    {
        include_once CONF.'access.cfg.php';
        $this->default_access = defaultAccessCFG();
    }
    public function loadRules()
    {
        global $core;
        $this->role_access = $core::$dbs->getPrevilegies($core::$user->getRole());

        return true;
    }
    public function getNodeAccess($nodename)
    {
        return (isset($this->role_access[$nodename]))?$this->role_access[$nodename]:
            ((isset($this->default_access[$nodename])) ? $this->default_access[$nodename] : 1);//0);
    }
}
