<?php
/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 23.04.13
*     Time: 16:05
*  Version: 1.0.0
*   Script: hStation CMS
*/

function __console($debug = false, $start_time = null)
{
    if ($debug == true) {
        echo'<label class="continer" style="width: 98%; display:block;padding: 1%;font-size: .8em;">';
        echo'<b>SESSION:</b><br/>';
        var_dump($_SESSION);
        echo'<br/>';
        echo'<b>POST:</b><br/>';
        var_dump($_POST);
        echo'<br/>';
        echo'<b>GET:</b><br/>';
        var_dump($_GET);
        echo'<br/>';
        echo'<b>COOKIE:</b><br/>';
        var_dump($_COOKIE);
        echo'<br/>';
        echo'<b>TIME EXEC:</b><br/>';
        echo $exec_time = microtime(true) - $start_time;
        echo'<br/>';
        echo'</label>';
    }
}
/**********************************************************************************************************************/
function __first_load($dir)
{
    if (isset($_POST['install'])) {
        $file = file_get_contents($dir.'dbs.cfg.sample.php');
        foreach ($_POST['install'] as $install => $data) {
            $config_str = "define('".strtoupper($install)."', '')";
            $new_config_str = "define('".strtoupper($install)."', '".$data."')";
            $file = str_replace($config_str, $new_config_str, $file);
        }
        $fp = fopen($dir.'dbs.cfg.php', "w+");
        fwrite($fp, $file);
        fclose($fp);
        require_once($dir.'dbs.cfg.php');
        $connect  = mysql_connect(DB_HOST, DB_USER, DB_PASSWORD) or die('[Install] Database connection error.');
        if (!mysql_select_db(DB_NAME, $connect)) {
            die('[Install] Select database error.');
        }
        $index = __index();
        include(CONTROL.'query.php');
        foreach ($install_query_drop as $query => $value) {
            mysql_query($value) or die('[Install] Query error.');
        }
        foreach ($install_query_create as $query => $value) {
            mysql_query($value) or die('[Install] Query error.');
        }
        foreach ($install_query_insert as $query => $value) {
            mysql_query($value) or die('[Install] Query error.');
        }
        $ava_default = ABSPATH.'content/uploads/images/avatars_default.png';
        copy($ava_default, ABSPATH.'content/uploads/images/'.md5($_POST['install']['st_email']).'.png');
        header("Location: http://".$_SERVER["HTTP_HOST"]);
    } else {
        $i_tpl = file_get_contents(CONTROL.'theme/install.html');
        print_r($i_tpl);
    }
}

/**
 * @param string $request - get query key
 * @return bool
 */
function __now($request)
{
    return (isset($_GET[$request]))?true:false;
}
/**
 * @param string $dirName - name of includes directory
 * @param array or null $excepts - no included files[default null]
 */
function __include_dir($dirName, $excepts = null)
{
    $default_excepts = array('.', '..', 'Thumbs.db', '.DS_Store');
    if ($excepts!=null) {
        if (is_array($excepts)) {
            $default_excepts += $excepts;
        } else {
            if (is_string($excepts)) {
                $default_excepts[] = $excepts;
            }
        }
    }
    if (($files = scandir($dirName)) != false) {
        foreach ($files as $f) {
            if (!array_search($f, $default_excepts) && is_file($dirName . $f)) {
                require_once($dirName . $f);
            }
        }
    }
}

function __join_file($file)
{
    if (file_exists($file)) {
        include $file;
    }
}
/**
 * @param string $dirName - name of includes directory
 * @param array or null $excepts - no included files[default null]
 */
function __include_kernel_configs($dirName, $excepts = null)
{
    $default_excepts = array('.', '..', 'Thumbs.db', '.DS_Store','kernel.cfg.php','dbs.cfg.sample.php');
    if ($excepts != null) {
        if (is_array($excepts)) {
            $default_excepts += $excepts;
        } else {
            if (is_string($excepts)) {
                $default_excepts[] = $excepts;
            }
        }
    }
    if (($files = scandir($dirName)) != false) {
        foreach ($files as $f) {
            if (!array_search($f, $default_excepts) && is_file($dirName . $f)) {
                if (!file_exists($dirName.'dbs.cfg.php')) {
                        __first_load($dirName);
                    exit();
                } else {
                    include($dirName . $f);
                }

            }
        }
    }
}
/**
 * @param $str
 * @param $depth
 * @return string
 */
function __date($str, $depth)
{
    switch ($depth) {
        case 'time':
            ($str != '0000-00-00 00:00:00')? $date_format = date("M j Y, H:i", strtotime($str)):$date_format = '';
            break;
        case 'short':
            ($str != '0000-00-00 00:00:00')? $date_format = date("M j Y", strtotime($str)):$date_format = '';
            break;
        default:
            ($str != '0000-00-00 00:00:00')? $date_format = date("F j Y", strtotime($str)):$date_format = '';
    }

    return $date_format;
}
/**
 * @param $str
 * @param $len
 * @return string
 */
function __shortenStr($str, $len)
{
    mb_internal_encoding("UTF-8");

    return mb_strlen($str) > $len ?  mb_substr($str, 0, $len)."" : $str;
}
/**
 * @param $email
 * @return bool
 */
function __checkEmail($email)
{
    if (mb_ereg("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,4}$", $email)) {
        return true;
    } else {
        return false;
    }
}
/**
 * @param $str
 * @param $symbs
 * @return string
 */
function __cutStr($str, $symbs)
{
    $cuts="";
    $words = explode(" ", $str);
    for ($i=0; $i < count($words); $i++) {
        $nv_str=$cuts.$words[$i]." ";
        if (strlen($nv_str)<$symbs) {
            $cuts= $nv_str;
        } else {
            break;
        }
    }

    return $cuts;
}
