<?php
/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 23.04.13
*     Time: 16:05
*  Version: 1.0.0
*   Script: hStation CMS
*/
/**
 * Generates and returns a unique 19 character string
 * @return string
 */
function __unique()
{
    $code = '';
    $symbols = '0123456789abcdefghijklmnopqrstuvwxyz_-';
    for ($i = 0; $i < (int) 19; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $code .= substr($symbols, $num, 1);
    }

    return $code;
}
/**
 * Generates and returns a unique 7-10 character password
 * @return string
 */
function __uniPass()
{
    $code = '';
    $k = mt_rand(7, 10);
    $symbols = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    for ($i = 0; $i < (int) $k; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $code .= substr($symbols, $num, 1);
    }

    return $code;
}

/**
 * Generates and returns a unique index key
 * @return string
 */
function __index()
{
    $index = '';
    $symbols = '0123456789MHOSTPLREA';
    $numbers = '0123456789';

    $first_key = '';
    $second_key = '';
    $num_key = '';
    for ($i = 0; $i < 4; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $first_key .= substr($symbols, $num, 1);
    }
    for ($i = 0; $i < 3; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $second_key .= substr($symbols, $num, 1);
    }
    for ($i = 0; $i < 6; $i++) {
        $num = mt_rand(1, strlen($numbers));
        $num_key .= substr($numbers, $num, 1);
    }
    $index .= '0-'.$first_key.'-'.$second_key.'-'.$num_key.'-0-'.substr($numbers, mt_rand(1, 9), 1).':0:0:';

    return $index;
}
/**
 * Generates and returns a unique key from pay system
 * @return string
 */
function __pay_unikey()
{
    $index = '';
    $symbols = '0123456789MHOSTPLREA';
    $numbers = '0123456789';

    $first_key = '';
    $second_key = '';
    $num_key = '';
    for ($i = 0; $i < 4; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $first_key .= substr($symbols, $num, 1);
    }
    for ($i = 0; $i < 3; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $second_key .= substr($symbols, $num, 1);
    }
    for ($i = 0; $i < 6; $i++) {
        $num = mt_rand(1, strlen($numbers));
        $num_key .= substr($numbers, $num, 1);
    }
    $index .= mt_rand(1, 9).'-'.$first_key.'-'.$second_key.'-'.$num_key.'-'.mt_rand(1, 9).'-';
    $index .= substr($numbers, mt_rand(1, 9), 1).'-'.mt_rand(1, 9);

    return $index;
}

/**
 * Generates and returns a new voucher
 * @return string
 */
function __bonus_voucher()
{
    $index = '';
    $symbols = '0123456789';
    $numbers = '0123456789';

    $first_key = '';
    $second_key = '';
    $num_key = '';
    for ($i = 0; $i < 3; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $first_key .= substr($symbols, $num, 1);
    }
    for ($i = 0; $i < 4; $i++) {
        $num = mt_rand(1, strlen($symbols));
        $second_key .= substr($symbols, $num, 1);
    }
    for ($i = 0; $i < 3; $i++) {
        $num = mt_rand(1, strlen($numbers));
        $num_key .= substr($numbers, $num, 1);
    }
    $index .= $first_key.'-'.$second_key.'-'.$num_key;

    return $index;
}
