/**
 * Created by backup on 10.02.14.
 * HM:SCRIPT Interface
 */
var popup_type = ['error','success'];
function __query(url, param, success_function) {
    var http;
    try {
        http = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
        try {
            http = new ActiveXObject("Microsoft.XMLHTTP");
        } catch (E) {
            http = false;
        }
    }
    if (!http && typeof XMLHttpRequest!='undefined') {
        http = new XMLHttpRequest();
    }
    xmlHttp = http;
    xmlHttp.open("POST", url, true);
    xmlHttp.onreadystatechange = success_function;
    xmlHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xmlHttp.send(param);
}
function __cookie(param,command){
    switch (command){
        case 'view':
            var strEnd = document.cookie.indexOf (";", param);
            if (strEnd == -1)
                strEnd = document.cookie.length;
            return unescape(document.cookie.substring(param, strEnd));
            break;
        case 'delete':
            var cookie_date = new Date ( );  // Текущая дата и время
            cookie_date.setTime ( cookie_date.getMonth()-1);
            document.cookie = param +'=; expires='+cookie_date.toGMTString()+';';
            break;
        default:
            var key = param + "=";
            var i = 0;
            while (i < document.cookie.length) {
                var j = i + key.length;
                if (document.cookie.substring(i, j) == key)
                    return __cookie(j,'view');
                i = document.cookie.indexOf(" ", i) + 1;
                if (i == 0)
                    break;
            }
            return null;
    }
}
function __popup(str,type){
    switch (type){
        case'error':
            $('[data-html]').prepend('<div class="alert box_red popup"><strong>Ошибка!</strong> '+str+'</div>');
            break;
        case'success':
            $('[data-html]').prepend('<div class="alert box_green popup"><strong>ок!</strong> '+str+'</div>');
            break;
    }
    $('.popup').fadeOut(4000);
}
var _Url = window.location;
$(document).ready(function(){
    switch (__cookie('errors')) {
        case 'register':
            __popup('Такой e-mail уже зарегистрирован.',popup_type[0]);
            break;
        case 'register_email':
            __popup('Не верный  e-mail.',popup_type[0]);
            break;
        case 'forgot_email':
            __popup('Такой e-mail не зарегистрирован.',popup_type[0]);
            break;
    }
    $('[data-href]').click(function(){
        _Url.href= $(this).attr('data-href');
    });
    $('[data-select]').click(function(){
        var par = $(this);
        if(par.hasClass('selected')){
            par.removeClass('selected');
            $('.hmi-select-list[data-selected="'+par.attr('data-id')+'"]').remove();
        }
        else {
            par.addClass('selected');
            par.after('<ul class="hmi-select-list" data-selected="'+par.attr('data-id')+'"></ul>');
            var new_li = '';
            par.children('select').each(function(){
                var opt = $(this).children();
                for (i = 0; i < opt.length; i++) {
                    new_li = new_li +'<li data-option="'+i+'">'+opt[i].text+'</li>';
                }
            });
            $('.hmi-select-list[data-selected="'+par.attr('data-id')+'"]').append(new_li);
        }
        $('.hmi-select-list[data-selected="'+par.attr('data-id')+'"]').mouseleave(function(){
            par.removeClass('selected');
            $(this).remove();
        });
        $('.hmi-select-list li').click(function(){
            par.children('.hmi-select-inner').html($(this).text());
            par.removeClass('selected');
            $('.hmi-select-list[data-selected="'+par.attr('data-id')+'"]').remove();
            var option = par.children('select').children();
            $(par.children('select')).children().each(function(){
                $(this).attr("selected", false);
            });
            $(option[$(this).attr('data-option')]).attr("selected", "selected");
        });
    });
    $('[data-number]').bind("change keyup input click", function() {
        if (this.value.match(/[^0-9]/g)) {
            this.value = this.value.replace(/[^0-9]/g, '');
        }


    });
    $('[data-api]').click(function(){
        var api_cmd = $(this).attr('data-api');
        __query('/?api&'+api_cmd,'',function(){
            if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete") {
                switch (api_cmd){
                    case'newpassword':
                        $('*[name="user[password]"]').attr('value',xmlHttp.responseText);
                        break;
                    case'newvoucher':
                        $('*[name="voucher"]').attr('value',xmlHttp.responseText);
                        break;
                }
            }
        });

    });
});


