<?php

/* Created: HM:Script
*  Website: http://hmscript.net
*     User: ZpVs
*     Date: 23.04.13
*     Time: 16:05
*  Version: 1.0.0
*   Script: hStation CMS
*/
require_once __DIR__  . '/hs-path.php';

/** Excretion errors when the script runs. */
//error_reporting(E_ALL);
error_reporting(0);
ini_set('display_errors', 0);


/** Connecting to initialize the class loader and the kernel boot. */
require_once __DIR__  . '/core/kernel/HmClassLoader.php';
    $loader = new \Core\Kernel\HmClassLoader;
    $loader->register();
    $loader->addNamespace('Core\Kernel', __DIR__.'/core/kernel');

/** Check and connect the configuration file for the working site. */
if (file_exists(ABSPATH.'core/configs/kernel.cfg.php')) {
    require_once(ABSPATH.'core/configs/kernel.cfg.php');
}
/** Connect the configuration files **/
__include_kernel_configs(CONF);


/** Initialization core builder. */
$builder = new  \Core\Kernel\HmsBuilder;

/** Loading core system connecting all the necessary extensions. */
$core = $builder->compileKernel();

/** Initialize the data processing tools kernel. */
$core::$engine->initEngineHandler();

/** Initialize and draw the site template. */
$core::$template->initTheme();
